#include <sqlextract/tables/table_singlerow.h>
#include <sqlextract/tables/table.h>
#include <sqlextract/filter/arbval.h>
#include <sqlextract/util.h>

struct table_singlerow_t {

};
struct table_singlerow_iter_t {
	int rowsleft;
	struct arbval_t *fieldval;
};


static void *table_singlerow_create(struct strid_t *si, void *fp);
static void table_singlerow_destroy(void *tsrp);
static void *table_singlerow_create_iterator(void *tsrp);
static int table_singlerow_fetch_row(void *itp);
static struct arbval_t *table_singlerow_fetch_field(void *itp, int fieldname);
static void table_singlerow_destroy_iterator(void *it);

struct table_desc_t table_singlerow = { table_singlerow_create,
		table_singlerow_destroy, table_singlerow_create_iterator,
		table_singlerow_fetch_row, table_singlerow_fetch_field,
		table_singlerow_destroy_iterator };

static void *table_singlerow_create(struct strid_t *si, void *fp) {
	struct table_singlerow_t *tsr = lf_malloc(sizeof(struct table_singlerow_t));
	return tsr;
}

static void table_singlerow_destroy(void *tsrp) {
	struct table_singlerow_t *tsr = (struct table_singlerow_t*) tsrp;
	free(tsr);
}

static void *table_singlerow_create_iterator(void *tsrp) {
	struct table_singlerow_iter_t *it = lf_malloc(
			sizeof(struct table_singlerow_iter_t));
	it->rowsleft = 1;
	it->fieldval = arbval_create_null();
	return it;

}

static int table_singlerow_fetch_row(void *itp) {
	struct table_singlerow_iter_t *it = (struct table_singlerow_iter_t *) itp;
	if( it->rowsleft > 0 ) {
		it->rowsleft--;
		return 1;
	}
	return 0;
}

static struct arbval_t *table_singlerow_fetch_field(void *itp, int fieldname) {
	struct table_singlerow_iter_t *it = (struct table_singlerow_iter_t *) itp;
	arbval_typecast_null(it->fieldval);
	return it->fieldval;
}
static void table_singlerow_destroy_iterator(void *itp) {
	struct table_singlerow_iter_t *it = (struct table_singlerow_iter_t *) itp;
	arbval_destroy(it->fieldval);
	free(it);

}
